#include "calc.h"

#include <math.h>
#include <stdlib.h>

#include "os_dep.h"

extern char *ecran1;

int screen_number=0;

int cos_tab[512+400];

void calc_palette(int c11, int c12, int c13, int c21, int c22, int c23)
{
  int i, j, k;
  char palette[256*3];
  int pre_1[16][3], pre_2[16][3];
  int col1[3], col2[3];
  col1[0]=c11;  col1[1]=c12;  col1[2]=c13;
  col2[0]=c21;  col2[1]=c22;  col2[2]=c23;

  for(i=0; i<16; i++) {
      pre_1[i][0]=(float)col1[0]*(float)i/15.;
      pre_2[i][0]=(float)col2[0]*(float)i/15.;
      pre_1[i][1]=(float)col1[1]*(float)i/15.;
      pre_2[i][1]=(float)col2[1]*(float)i/15.;
      pre_1[i][2]=(float)col1[2]*(float)i/15.;
      pre_2[i][2]=(float)col2[2]*(float)i/15.;
  }

  for (i=0; i<256; i++) {
    int l;
    j=i>>4;
    k=i&15;
    l=(pre_1[j][0]+pre_2[k][0]);
    palette[i*3+0]= l >255 ? 63 :l>>2;
    l=pre_1[j][1]+pre_2[k][1];
    palette[i*3+1]= l >255 ? 63 :l>>2;
    l=pre_1[j][2]+pre_2[k][2];
    palette[i*3+2]= l >255 ? 63 :l>>2;
  }

  put_palette(palette);
}

/* retourne 0 si pb 1 sinon */
int init_calc(void)
{
  int i;

  for (i=0; i<512+400; i++)
    cos_tab[i]=cos(M_PI*2*(double)i/512)*400;

  calc_palette(150, 160, 255, 255, 255, 150);

  return 1;
}

int calc(int nb)
{
  static int a1=150, a2=10, a3=30, a4=40, a5=50, a6=16, a7=200, a8=400;
  static int ia1=2, ia2=-5, ia3=3, ia4=-2, ia5=-4, ia6=3, ia7=4, ia8=6;

  screen_number+=nb;
  
  if (screen_number>4000) return 0;

  if (screen_number<16*4) {
    int a=screen_number>>2;
    calc_palette(150*a/15, 160*a/15, 255*a/15, 0, 0, 0);
  } else if(screen_number<16*4*2) {
    int a=(screen_number>>2)-16;
    calc_palette(150, 160, 255, 255*a/15, 255*a/15, 150*a/15);
  }
  if (screen_number>16*4*2/*+32*/) {
    int a=screen_number-16*4*2/*-32*/;
    if (a<16*4) {
      int b=16-(a>>2);
      calc_palette(150*b/15, 160*b/15, 255*b/15, 255, 255, 150);
    } else if (a<16*4*2) {
      int b=16-((a-16*4)>>2);
      calc_palette(0, 0, 0, 255*b/15, 255*b/15, 150*b/15);
    } else return 0;
  }

  {
    register int i, j, k=0;
    int al=0, z;

    for (i=0; i<200; i++) {
      z=0;
      for (j=0; j<320; j++) {
	int u=((cos_tab[(a1+i)]+z)>>4), v= (cos_tab[(a2+j)]+al)>>4;
	int u1=((cos_tab[(a3+i)]+z)>>4), v1= (cos_tab[(a4+j)]+al)>>4;
	int _u=((cos_tab[(a5+i)]+z)>>4), _v= (cos_tab[(a6+j)]+al)>>4;
	int _u1=((cos_tab[(a7+i)]+z)>>4), _v1= (cos_tab[(a8+j)]+al)>>4;
	*(ecran1+(k++))=(((v+ v1+u+u1)&15) | (((_u+_u1+_v+_v1)&15)<<4));
	z++;
      }
      al++;
    }
    /*
      for (k=0; k<64000; k++) {
      i=25.0*rand()/(RAND_MAX+1.0);
      *(ecran+k)=*(ecran1+k+i);
      }
      asm("movl (ecran1), %esi;"
      "movl (ecran), %edi;"
      "movl $16000, %ecx;"
      "cld;"
      "rep;"
      "movsl");
      */
  }

#if 0
  calc_palette(cos_tab[a1]&255, cos_tab[a2]&255, cos_tab[a3]&255,
	       cos_tab[a4+300]&255, cos_tab[a5+300]&255, cos_tab[a6+300]&255);
#endif

  {
    a1+=ia1*nb;
    a2+=ia2*nb;
    a3+=ia3*nb;
    a4+=ia4*nb;
    a5+=ia5*nb;
    a6+=ia6*nb;
    a7+=ia7*nb;
    a8+=ia8*nb;
    a1&=511;
    a2&=511;
    a3&=511;
    a4&=511;
    a5&=511;
    a6&=511;
    a7&=511;
    a8&=511;
  }

  return 1;
}
