/* des routines os dependantes (a la base, c'est linux, dos a voir (djgpp...)) */

extern void new_put_palette(char *);
extern void new_put_screen(void);

char *screen;

#include "os_dep.h"

extern char *ecran1;
/**********************************
 * Section 1 : les routines ecran *
 **********************************/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
#include <stdio.h>

Display *X_ecran;
Colormap map;
Window la_win;
GC gcontext;
XImage *X_image;

int svga=0;

/* retourne 0 si pb 1 sinon */
int init_screen(void)
{
  X_ecran=XOpenDisplay(0);
    
  if (!X_ecran) svga=1;
    
  if (!svga) {
    XVisualInfo *les_infos, vtemp;
    XSetWindowAttributes attributs;
    int nb_temp;
    XGCValues gcv;
    
    vtemp.depth=8;
    vtemp.colormap_size=256;
    les_infos=XGetVisualInfo(X_ecran, VisualDepthMask|VisualColormapSizeMask, &vtemp, &nb_temp);
    if (!les_infos) {
      fprintf(stderr, "problem with XGetVisualInfo, sorry...\n");
      return 0;
    }
    map=XCreateColormap(X_ecran, DefaultRootWindow(X_ecran), les_infos[0].visual, AllocAll);
    attributs.colormap=map;
    attributs.background_pixel=255;
    /*  creer_les_couleurs(X_ecran, map);*/
    la_win=XCreateWindow(X_ecran, DefaultRootWindow(X_ecran), 0, 0, 320, 200, 3, 8, CopyFromParent, les_infos[0].visual,
			 CWColormap|CWBackPixel, &attributs);
    XSelectInput(X_ecran, la_win, KeyPressMask);
    XMapWindow(X_ecran, la_win);
    XFlush(X_ecran);
    gcv.foreground=BlackPixel(X_ecran, DefaultScreen(X_ecran));
    gcv.background=WhitePixel(X_ecran, DefaultScreen(X_ecran));
    gcontext=XCreateGC(X_ecran,la_win,GCForeground|GCBackground,&gcv);
    
    /* bitmap_pad, what the heck is it ?? mail p6mip300@infop6.cicrp.jussieu.fr if you know, please... */
    X_image=XCreateImage(X_ecran, les_infos[0].visual, 8, ZPixmap, 0, ecran1, 320, 200, 8, 0);
    
    XFree(les_infos);
    return 1;
  } else {
    GraphicsContext c;

    vga_init();
    vga_setmode(G320x200x256);
    gl_setcontextvga(G320x200x256);
    gl_getcontext(&c);
    screen=c.vbuf;
    return 1;
  }
}

void close_screen(void)
{
  if (!svga) {
    XDestroyWindow(X_ecran, la_win);
  } else {
    vga_setmode(TEXT);
  }
}

void put_screen(void)
{
  if (!svga) {
    XPutImage(X_ecran, la_win, gcontext, X_image,0,0,0,0,
	      X_image->width, X_image->height);
    XFlush(X_ecran);
  } else {
    new_put_screen();
  }
}

#include <X11/keysym.h>
#include <X11/Xutil.h>

int escape_pressed(void)
{
  if (!svga) {
    XEvent X_event;
    char buffer[15];
    KeySym key;
    XComposeStatus compose;
    if (XCheckWindowEvent(X_ecran, la_win, KeyPressMask, &X_event)) {
      XLookupString((XKeyEvent *)&X_event, buffer, 10, &key, &compose);
      if (key==XK_Escape) return 1;
    }
    return 0;
  } else {
    return 0;
  }
}

void put_palette(char * pal)
{
  if (!svga) {
    XColor color[256];
    int i;
    for (i=0; i<256; i++) {
      color[i].pixel=i;
      color[i].flags=DoRed|DoGreen|DoBlue;
      color[i].red=*(pal+i*3)<<10;
      color[i].green=*(pal+i*3+1)<<10;
      color[i].blue=*(pal+i*3+2)<<10;
    }
    XStoreColors(X_ecran, map, color, 256);
  } else
    new_put_palette(pal);
}

#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
#include <stdio.h>

/**********************************
 * Section 2 : les routines timer *
 **********************************/

#include <signal.h>
#include <sys/time.h>
#include <stdio.h>

/* on utilise un timer, on fait des pauses entre les screens */
/* les signaux POSIX, wooooo */

int nb_screen;

void timer(int n)
{
  nb_screen++;
}

/* 0 si pb 1 sinon */
int init_timer(int x)
{
  struct sigaction act;
  struct itimerval tim;

  nb_screen=0;

  act.sa_handler=timer;
  act.sa_mask=(sigset_t)0;
  act.sa_flags=0;
  act.sa_restorer=0;
  if(sigaction(SIGALRM, &act, (struct sigaction *)0)==-1) {
    fprintf(stderr, "erreur avec sigaction, sorry...\n");
    return 0;
  }

  /* un timer a 1/40ieme de sec */
  tim.it_interval.tv_sec=0;
  tim.it_interval.tv_usec=x*1000;
  tim.it_value.tv_sec=0;
  tim.it_value.tv_usec=x*1000;
  if(setitimer(ITIMER_REAL, &tim, (struct itimerval *)0)==-1) {
    fprintf(stderr, "erreur avec setitimer, sorry...\n");
    return 0;
  }

  return 1;
}

int tour=1;
void change_timer(void)
{
  if (tour) {
    struct itimerval tim;
    tim.it_interval.tv_sec=0;
    tim.it_interval.tv_usec=10*1000;
    tim.it_value.tv_sec=0;
    tim.it_value.tv_usec=10*1000;
    setitimer(ITIMER_REAL, &tim, (struct itimerval *)0);
  } else {
    struct itimerval tim;
    tim.it_interval.tv_sec=0;
    tim.it_interval.tv_usec=40*1000;
    tim.it_value.tv_sec=0;
    tim.it_value.tv_usec=40*1000;
    setitimer(ITIMER_REAL, &tim, (struct itimerval *)0);
  }
  tour++;
  tour&=1;
}

void close_timer(void)
{
  /* rien a faire, on va quitter juste apres, le process va et' kille
   * linux nettoie pour nous :)
   */
}

/* un wait a la posix, on bloque tous les signaux, on teste si ecran=0,
 * si oui, on fait un sigsuspend, sinon on remet les signaux et on retourne
 * ecran
 * retourne le nb d'ecran a sauter (-1 en fait, vu que ca rend 1 au min)
 */
int wait_timer(void)
{
  sigset_t act;
  int ret;

  sigemptyset(&act);
  sigaddset(&act, SIGALRM);
  sigprocmask(SIG_BLOCK, &act, (sigset_t *)0);

  if (nb_screen==0) {
    sigset_t t;
    sigemptyset(&t);
    sigsuspend(&t);
  }

  ret=nb_screen;
  nb_screen=0;

  sigprocmask(SIG_UNBLOCK, &act, (sigset_t *)0);

  return ret;
}
